diff --git a/drivers/common/sfc_efx/base/meson.build b/drivers/common/sfc_efx/base/meson.build
index 9fba47b1cc..ff7f33fb44 100644
--- a/drivers/common/sfc_efx/base/meson.build
+++ b/drivers/common/sfc_efx/base/meson.build
@@ -86,7 +86,7 @@ if build
         dependencies: static_rte_eal,
         c_args: c_args)
 
-    base_objs = base_lib.extract_all_objects()
+    base_objs = base_lib.extract_all_objects(recursive: true)
 else
     base_objs = []
 endif
diff --git a/drivers/meson.build b/drivers/meson.build
index bc6f4f567f..d9e331ec85 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -160,7 +160,7 @@ foreach subpath:subdirs
                 include_directories: includes,
                 dependencies: static_deps,
                 c_args: cflags)
-        objs += tmp_lib.extract_all_objects()
+        objs += tmp_lib.extract_all_objects(recursive: true)
         sources = custom_target(out_filename,
                 command: [pmdinfo, tmp_lib.full_path(), '@OUTPUT@', pmdinfogen],
                 output: out_filename,
diff --git a/drivers/net/e1000/base/meson.build b/drivers/net/e1000/base/meson.build
index 317692dfab..528a33f958 100644
--- a/drivers/net/e1000/base/meson.build
+++ b/drivers/net/e1000/base/meson.build
@@ -35,4 +35,4 @@ endforeach
 base_lib = static_library('e1000_base', sources,
     dependencies: static_rte_eal,
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/fm10k/base/meson.build b/drivers/net/fm10k/base/meson.build
index ca98d34d4e..bd19df27f7 100644
--- a/drivers/net/fm10k/base/meson.build
+++ b/drivers/net/fm10k/base/meson.build
@@ -25,4 +25,4 @@ endforeach
 base_lib = static_library('fm10k_base', sources,
     dependencies: static_rte_eal,
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/hinic/base/meson.build b/drivers/net/hinic/base/meson.build
index a00c90c14e..3aa53df881 100644
--- a/drivers/net/hinic/base/meson.build
+++ b/drivers/net/hinic/base/meson.build
@@ -34,4 +34,4 @@ c_args = cflags
 base_lib = static_library('hinic_base', sources,
     dependencies: [static_rte_eal, static_rte_ethdev, static_rte_bus_pci, static_rte_hash],
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/i40e/base/meson.build b/drivers/net/i40e/base/meson.build
index 79a887a297..d94108629b 100644
--- a/drivers/net/i40e/base/meson.build
+++ b/drivers/net/i40e/base/meson.build
@@ -27,4 +27,4 @@ endforeach
 base_lib = static_library('i40e_base', sources,
     dependencies: static_rte_eal,
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/ice/base/meson.build b/drivers/net/ice/base/meson.build
index 3305e5dd18..30e251876d 100644
--- a/drivers/net/ice/base/meson.build
+++ b/drivers/net/ice/base/meson.build
@@ -43,4 +43,4 @@ endforeach
 base_lib = static_library('ice_base', sources,
         dependencies: static_rte_eal,
         c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/igc/base/meson.build b/drivers/net/igc/base/meson.build
index 8affc72e65..f52421f7a9 100644
--- a/drivers/net/igc/base/meson.build
+++ b/drivers/net/igc/base/meson.build
@@ -16,4 +16,4 @@ base_lib = static_library('igc_base', sources,
     dependencies: static_rte_eal,
     c_args: cflags)
 
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/ixgbe/base/meson.build b/drivers/net/ixgbe/base/meson.build
index 7d3cec002d..22972c6b56 100644
--- a/drivers/net/ixgbe/base/meson.build
+++ b/drivers/net/ixgbe/base/meson.build
@@ -31,4 +31,4 @@ endforeach
 base_lib = static_library('ixgbe_base', sources,
     dependencies: static_rte_eal,
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/ngbe/base/meson.build b/drivers/net/ngbe/base/meson.build
index a1a9c2ff65..6081281135 100644
--- a/drivers/net/ngbe/base/meson.build
+++ b/drivers/net/ngbe/base/meson.build
@@ -18,4 +18,4 @@ c_args = cflags
 base_lib = static_library('ngbe_base', sources,
     dependencies: [static_rte_eal, static_rte_ethdev, static_rte_bus_pci],
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/octeontx/base/meson.build b/drivers/net/octeontx/base/meson.build
index c86a726704..8e5e8c1b55 100644
--- a/drivers/net/octeontx/base/meson.build
+++ b/drivers/net/octeontx/base/meson.build
@@ -22,4 +22,4 @@ base_lib = static_library('octeontx_base', sources,
     dependencies: static_objs,
 )
 
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/qede/base/meson.build b/drivers/net/qede/base/meson.build
index 614a0c3808..4ad177b478 100644
--- a/drivers/net/qede/base/meson.build
+++ b/drivers/net/qede/base/meson.build
@@ -54,4 +54,4 @@ endforeach
 base_lib = static_library('qede_base', sources,
     dependencies: [static_rte_net, static_rte_bus_pci],
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/thunderx/base/meson.build b/drivers/net/thunderx/base/meson.build
index 704ee65771..cec45d0ae1 100644
--- a/drivers/net/thunderx/base/meson.build
+++ b/drivers/net/thunderx/base/meson.build
@@ -13,4 +13,4 @@ base_lib = static_library('nicvf_base', sources,
     dependencies: static_rte_ethdev
 )
 
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/net/txgbe/base/meson.build b/drivers/net/txgbe/base/meson.build
index c6816b4279..7a30191472 100644
--- a/drivers/net/txgbe/base/meson.build
+++ b/drivers/net/txgbe/base/meson.build
@@ -24,4 +24,4 @@ endforeach
 base_lib = static_library('txgbe_base', sources,
     dependencies: static_rte_eal,
     c_args: c_args)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)
diff --git a/drivers/raw/ifpga/base/meson.build b/drivers/raw/ifpga/base/meson.build
index 8d27c60213..db602cee69 100644
--- a/drivers/raw/ifpga/base/meson.build
+++ b/drivers/raw/ifpga/base/meson.build
@@ -40,4 +40,4 @@ ext_deps += rtdep
 base_lib = static_library('ifpga_rawdev_base', sources,
     dependencies: static_rte_eal,
     c_args: cflags)
-base_objs = base_lib.extract_all_objects()
+base_objs = base_lib.extract_all_objects(recursive: true)